<template>
  <v-layout color="#f8f8f8">
    <v-flex md12 pa-1>
      <v-layout>
        <v-card class="mx-auto my-12" elevation="0" width="100%" height="100%">
          <v-layout v-if="!mobileView">
            <v-flex xs4>
              <div class="font-size-24-bold title-style">
                ประวัติการนำส่งภาษี
              </div>
            </v-flex>
            <v-flex xs2 style="margin: 16px 8px 16px 0px;">
              <v-text-field
                outline
                placeholder="Search"
                name="search"
                v-model="alltaxsearch"
                append-icon="search"
                style="width:100%;font-family: Sarabun, sans-serif;"
              >
              </v-text-field>
            </v-flex>
            <v-flex xs2 style="display: flex;justify-content: center;">
              <v-btn
                outline
                class="btn-advanced-search"
                @click="btnAdvancedSearch()"
                style="width: 100%;"
              >
                Advanced search
                <img
                  :src="images.down"
                  style="width: 24px;margin-left: 4px;"
                  v-if="advancedstatus === false"
                />
                <img
                  :src="images.arrow"
                  style="width: 24px;margin-left: 4px;"
                  v-if="advancedstatus === true"
                />
              </v-btn>
            </v-flex>
            <v-flex xs2 style="display: flex;justify-content: center;">
              <v-btn
                outline
                class="btn-advanced-search"
                :href="'https://rdserver.rd.go.th/publish/index.php'"
                :target="'_blank'"
              >
                Link to
                <img :src="images.efiling" style="height: 36px;" />
              </v-btn>
            </v-flex>
            <v-flex xs2 style="display: flex;justify-content: center;">
              <v-btn class="btn-export" @click="onExport()">
                Export to Excel
              </v-btn>
            </v-flex>
          </v-layout>

          <!-- ------------------------- mobileView ------------------------- -->
          <v-layout wrap v-if="mobileView">
            <v-flex xs="6">
              <div class="font-size-24-bold title-style">
                ประวัติการนำส่งภาษี
              </div>
            </v-flex>
            <v-flex xs="6" style="margin: 16px 8px 16px 0px;">
              <v-text-field
                outline
                placeholder="Search"
                name="search"
                v-model="alltaxsearch"
                append-icon="search"
                style="width:100%;font-family: Sarabun, sans-serif;"
              >
              </v-text-field>
            </v-flex>
            <v-flex xs="6" style="display: flex;justify-content: center;">
              <v-btn
                outline
                class="btn-advanced-search"
                @click="btnAdvancedSearch()"
                style="width: 100%;"
              >
                Advanced search
                <img
                  :src="images.down"
                  style="width: 24px;margin-left: 4px;"
                  v-if="advancedstatus === false"
                />
                <img
                  :src="images.arrow"
                  style="width: 24px;margin-left: 4px;"
                  v-if="advancedstatus === true"
                />
              </v-btn>
            </v-flex>
            <v-flex xs="6" style="display: flex;justify-content: center;">
              <v-btn
                outline
                class="btn-advanced-search"
                :href="'https://rdserver.rd.go.th/publish/index.php'"
                :target="'_blank'"
              >
                Link to
                <img :src="images.efiling" style="height: 36px;" />
              </v-btn>
            </v-flex>
            <v-flex xs="6" style="display: flex;justify-content: center;">
              <v-btn class="btn-export" @click="onExport()">
                Export to Excel
              </v-btn>
            </v-flex>
          </v-layout>
          <!-- ------------------------- End mobileView ------------------------- -->

          <div class="box-advanced" v-if="advancedstatus === true">
            <v-layout>
              <v-flex xs3 style="margin: 24px 8px 8px 24px;">
                <span class="text">RD Reference</span>
                <v-text-field
                  outline
                  name="rd_ref"
                  v-model="rd_ref"
                ></v-text-field>
              </v-flex>
              <v-flex xs3 style="margin: 24px 8px 8px 8px;">
                <span class="text">Grand Total</span>
                <v-text-field
                  outline
                  name="grandtotal"
                  v-model="grandtotal"
                ></v-text-field>
              </v-flex>
              <v-flex xs3 style="margin: 24px 8px 8px 8px;">
                <span class="text">Receiver Bank Code</span>
                <v-text-field
                  outline
                  name="receiver_bankcode"
                  v-model="receiver_bankcode"
                ></v-text-field>
              </v-flex>
              <v-flex xs3 style="margin: 24px 8px 8px 8px;">
                <span class="text">Receiver Tax ID</span>
                <v-text-field
                  outline
                  name="receiver_tax_id"
                  v-model="receiver_tax_id"
                ></v-text-field>
              </v-flex>
            </v-layout>

            <v-layout>
              <v-flex xs3 style="margin: 8px 8px 8px 24px;">
                <span class="text">Detail</span>
                <v-text-field
                  outline
                  name="detail"
                  v-model="detail"
                ></v-text-field>
              </v-flex>

              <v-flex xs3 style="margin: 8px;">
                <span class="text">Payment Date</span>
                <v-menu
                  v-model="menu"
                  :close-on-content-click="false"
                  :nudge-right="40"
                  transition="scale-transition"
                  offset-y
                  min-width="auto"
                >
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                      outline
                      :value="computedDateFormattedMomentjs"
                      v-model="date"
                      append-icon="mdi-calendar"
                      readonly
                      v-bind="attrs"
                      v-on="on"
                    ></v-text-field>
                  </template>
                  <v-date-picker
                    no-title
                    color="green lighten-1"
                    v-model="date"
                    @input="menu = false"
                  ></v-date-picker>
                </v-menu>
              </v-flex>
              <v-flex xs3 style="margin: 8px;"></v-flex>
              <v-flex xs3 style="margin: 8px;"></v-flex>
            </v-layout>
            <v-layout style="display: flex;justify-content: flex-end;">
              <v-btn outline class="btn-reset" @click="reset()">
                Reset
              </v-btn>
            </v-layout>
          </div>

          <div v-if="role == 'User'">
            <v-flex md12 pa-1>
              <!-- table desktop -->
              <v-data-table
                v-model="selected"
                :rows-per-page-items="rowperpage"
                :pagination.sync="pagination"
                class="elevation-0 custom-table-cell table-style"
                :headers="headers"
                :items="taxview"
                :search="alltaxsearch"
                item-key="order_id"
                v-if="!mobileView"
                disable-initial-sort
              >
                <template
                  v-slot:items="props"
                  v-bind:class="{ 'active-class-name': isActive(sidemenu) }"
                >
                  <tr style="cursor: pointer;" @click="openDialogDetail(props)">
                    <td class="text-xs-left">
                      {{ props.item.rd_reference }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.receiver_company }}
                    </td>
                    <td class="text-xs-left">{{ props.item.wht_amount }}</td>
                    <td class="text-xs-center">
                      <v-chip
                        label
                        disabled
                        :color="setStatusColor(props.item.tax_information)"
                        :text-color="setTextColor(props.item.tax_information)"
                        text-font="center"
                        style="width:90px; justify-content: center;font-weight:bold"
                        >{{ props.item.tax_information }}
                      </v-chip>
                    </td>
                    <td class="text-xs-left">
                      <v-chip
                        label
                        disabled
                        :color="setStatusColor(props.item.tranfer)"
                        :text-color="setTextColor(props.item.tranfer)"
                        text-font="center"
                        style="width:90px; justify-content: center;font-weight:bold"
                        >{{ props.item.tranfer }}
                      </v-chip>
                    </td>
                    <td class="text-xs-left">
                      <v-chip
                        label
                        disabled
                        :color="setStatusColor(props.item.reconcile)"
                        :text-color="setTextColor(props.item.reconcile)"
                        text-font="center"
                        style="width:90px; justify-content: center;font-weight:bold"
                        >{{ props.item.reconcile }}
                      </v-chip>
                    </td>
                    <!-- ---------------------  Dialog Resend --------------------- -->
                    <!-- Resend Role User -->
                    <td
                      class="text-xs-center"
                      v-if="role == 'User'"
                      style="cursor: pointer;"
                    >
                      <v-dialog v-model="dialog" persistent max-width="700px">
                        <template v-slot:activator="{ on, attrs }">
                          <div
                            v-if="
                              props.item.tax_information === 'Rejected' &&
                                role == 'User'
                            "
                          >
                            <v-btn
                              outline
                              class="btn-resend"
                              v-bind="attrs"
                              v-on="on"
                              @click="resendTaxInfo(props.item)"
                            >
                              Resend
                            </v-btn>
                          </div>
                          <div v-else></div>
                        </template>
                        <v-card>
                          <v-form v-model="isFormValid">
                            <v-card-title>
                              <span class="title"
                                >RD Reference: {{ pvno }}</span
                              >
                            </v-card-title>
                            <v-card-text>
                              <v-container>
                                <v-layout class="text-dialog">
                                  <v-flex>
                                    <span
                                      >Receiver Account Name
                                      <span class="red--text">*</span></span
                                    >

                                    <!-- () =>
                                          /^[a-zA-Z\s]+$/.test(name) ||
                                          'Name must be character' -->
                                    <v-text-field
                                      outline
                                      name="name"
                                      v-model="name"
                                      disabled
                                      :rules="[
                                        () => !!name || 'This field is required'
                                      ]"
                                    ></v-text-field>
                                  </v-flex>
                                </v-layout>
                                <v-layout class="text-dialog">
                                  <v-flex xs6 style="padding-right: 10px;">
                                    <span
                                      >Receiver Account No<span
                                        class="red--text"
                                        >*</span
                                      >
                                    </span>

                                    <v-text-field
                                      outline
                                      name="account"
                                      v-model="account"
                                      disabled
                                      :rules="[
                                        () =>
                                          !!account || 'This field is required'
                                      ]"
                                    >
                                    </v-text-field>
                                  </v-flex>
                                  <v-flex xs6>
                                    <span
                                      >Receiver Bank Code
                                      <span class="red--text">*</span></span
                                    >
                                    <v-text-field
                                      outline
                                      name="bankcode"
                                      v-model="bankcode"
                                      disabled
                                      :rules="[
                                        () =>
                                          !!bankcode || 'This field is required'
                                      ]"
                                    >
                                    </v-text-field>
                                  </v-flex>
                                </v-layout>

                                <v-layout class="text-dialog">
                                  <v-flex xs6 style="padding-right: 10px;">
                                    <span
                                      >Receiver Tax ID
                                      <span class="red--text">*</span></span
                                    >
                                    <v-text-field
                                      outline
                                      name="tax_id"
                                      v-model="tax_id"
                                      :rules="[
                                        () =>
                                          !!tax_id || 'This field is required',
                                        () =>
                                          /^\d+$/.test(tax_id) ||
                                          'Tax ID must be number'
                                      ]"
                                    >
                                    </v-text-field>
                                  </v-flex>
                                  <v-flex xs6>
                                    <span
                                      >Wht Condition
                                      <span class="red--text">*</span></span
                                    >
                                    <v-select
                                      outline
                                      :items="wht_cons"
                                      name="wht_condition"
                                      v-model="wht_condition"
                                      :rules="[
                                        () =>
                                          !!wht_condition ||
                                          'This field is required'
                                      ]"
                                    ></v-select>
                                  </v-flex>
                                </v-layout>

                                <v-layout class="text-dialog">
                                  <v-flex>
                                    <span
                                      >Type of Income<span class="red--text"
                                        >*</span
                                      ></span
                                    >
                                    <v-select
                                      outline
                                      :items="income_types"
                                      name="income_type"
                                      v-model="income_type"
                                      :rules="[
                                        () =>
                                          !!income_type ||
                                          'This field is required'
                                      ]"
                                    ></v-select>
                                  </v-flex>
                                </v-layout>
                              </v-container>
                            </v-card-text>
                            <v-card-actions>
                              <v-spacer></v-spacer>
                              <v-btn
                                outline
                                class="btn-reset"
                                text
                                @click="dialog = false"
                              >
                                Close
                              </v-btn>
                              <v-btn
                                class="btn-save"
                                text
                                @click="onSaveTaxInfo()"
                                :disabled="!isFormValid"
                              >
                                Save
                              </v-btn>
                            </v-card-actions>
                          </v-form>
                        </v-card>
                      </v-dialog>
                    </td>

                    <!-- Resend Role Admin -->
                    <!-- <td class="text-xs-center" v-if="role == 'Admin'">
                      <v-dialog v-model="dialog" persistent max-width="600px">
                        <template v-slot:activator="{ on, attrs }">
                          <div
                            v-if="
                              props.item.tranfer === 'Rejected' &&
                                role == 'Admin'
                            "
                          >
                            <v-btn
                              outline
                              class="btn-resend"
                              v-bind="attrs"
                              v-on="on"
                              @click="
                                resendTransfer(rd_data, props.item.rd_reference)
                              "
                            >
                              Resend
                            </v-btn>
                          </div>
                          <div v-else></div>
                        </template>
                        <v-card>
                          <v-form v-model="isFormValid">

                            <v-card-text>
                              <v-container>
                                <v-layout>
                                  <v-flex>
                                    <span
                                      >RD Account Name
                                      <span class="red--text">*</span></span
                                    >
                                    <v-text-field
                                      outline
                                      name="name_rd"
                                      v-model="name_rd"
                                      :rules="[
                                        () =>
                                          !!name_rd || 'This field is required',
                                        () =>
                                          /^[a-zA-Z\s]+$/.test(name_rd) ||
                                          'Name must be character'
                                      ]"
                                    ></v-text-field>
                                  </v-flex>
                                </v-layout>
                                <v-layout>
                                  <v-flex xs6 style="padding-right: 10px;">
                                    <span
                                      >RD Account No
                                      <span class="red--text">*</span></span
                                    >
                                    <v-text-field
                                      outline
                                      name="account_no_rd"
                                      v-model="account_no_rd"
                                      :rules="[
                                        () =>
                                          !!account_no_rd ||
                                          'This field is required'
                                      ]"
                                    >
                                    </v-text-field>
                                  </v-flex>
                                  <v-flex xs6>
                                    <span
                                      >RD Bank Code
                                      <span class="red--text">*</span></span
                                    >
                                    <v-text-field
                                      outline
                                      name="bankcode_rd"
                                      v-model="bankcode_rd"
                                      :rules="[
                                        () =>
                                          !!bankcode_rd ||
                                          'This field is required'
                                      ]"
                                    >
                                    </v-text-field>
                                  </v-flex>
                                </v-layout>
                              </v-container>
                            </v-card-text>
                            <v-card-actions>
                              <v-spacer></v-spacer>
                              <v-btn
                                outline
                                class="btn-reset"
                                text
                                @click="dialog = false"
                              >
                                Close
                              </v-btn>

                              <v-btn
                                class="btn-save"
                                text
                                @click="onSaveTransfer()"
                                :disabled="!isFormValid"
                              >
                                Save
                              </v-btn>
                            </v-card-actions>
                          </v-form>
                        </v-card>
                      </v-dialog>
                    </td> -->
                    <!-- --------------------- End Dialog Resend --------------------- -->

                    <!-- <td class="text-xs-left">
                      {{ props.item.order_id }}
                    </td>
                    <td class="text-xs-left">{{ props.item.payment_date }}</td>
                    <td class="text-xs-left">{{ props.item.payment_time }}</td>
                    <td
                      class="text-xs-left"
                      style="min-width:200px;max-width: 200px;"
                    >
                      {{ props.item.detail }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.name }}
                    </td>

                    <td class="text-xs-left">
                      {{ props.item.receiver_tax_id }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.receiver_account_no }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.receiver_bank_code }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.receiver_email }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.income_type }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.amount_exc_vat }}
                    </td>
                    <td class="text-xs-left">{{ props.item.vat_amount }}</td>
                    <td class="text-xs-left">{{ props.item.grand_total }}</td>
                    <td class="text-xs-left">{{ props.item.wht_rate }} %</td>
                    <td class="text-xs-left">{{ props.item.payer_tax_id }}</td> -->
                  </tr>
                </template>
              </v-data-table>
              <!-- end table desktop -->

              <!-- table mobile -->
              <v-data-table
                v-model="selected"
                :rows-per-page-items="rowperpage"
                :pagination.sync="pagination"
                class="elevation-0 custom-table-cell table-style"
                :headers="headers"
                :items="taxview"
                :search="alltaxsearch"
                item-key="order_id"
                v-if="mobileView"
                disable-initial-sort
              >
                <template
                  v-slot:items="props"
                  v-bind:class="{ 'active-class-name': isActive(sidemenu) }"
                >
                  <tr style="cursor: pointer;" @click="openDialogDetail(props)">
                    <td class="text-xs-left">
                      {{ props.item.rd_reference }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.receiver_company }}
                    </td>
                    <td class="text-xs-left">{{ props.item.wht_amount }}</td>
                    <td class="text-xs-center">
                      <v-chip
                        label
                        disabled
                        :color="setStatusColor(props.item.tax_information)"
                        :text-color="setTextColor(props.item.tax_information)"
                        text-font="center"
                        style="width:90px; justify-content: center;font-weight:bold"
                        >{{ props.item.tax_information }}
                      </v-chip>
                    </td>
                    <td class="text-xs-left">
                      <v-chip
                        label
                        disabled
                        :color="setStatusColor(props.item.tranfer)"
                        :text-color="setTextColor(props.item.tranfer)"
                        text-font="center"
                        style="width:90px; justify-content: center;font-weight:bold"
                        >{{ props.item.tranfer }}
                      </v-chip>
                    </td>
                    <td class="text-xs-left">
                      <v-chip
                        label
                        disabled
                        :color="setStatusColor(props.item.reconcile)"
                        :text-color="setTextColor(props.item.reconcile)"
                        text-font="center"
                        style="width:90px; justify-content: center;font-weight:bold"
                        >{{ props.item.reconcile }}
                      </v-chip>
                    </td>
                    <!-- ---------------------  Dialog Resend --------------------- -->
                    <!-- Resend Role User -->
                    <td
                      class="text-xs-center"
                      v-if="role == 'User'"
                      style="cursor: pointer;"
                    >
                      <v-dialog v-model="dialog" persistent max-width="700px">
                        <template v-slot:activator="{ on, attrs }">
                          <div
                            v-if="
                              props.item.tax_information === 'Rejected' &&
                                role == 'User'
                            "
                          >
                            <v-btn
                              outline
                              class="btn-resend"
                              v-bind="attrs"
                              v-on="on"
                              @click="resendTaxInfo(props.item)"
                            >
                              Resend
                            </v-btn>
                          </div>
                          <div v-else></div>
                        </template>
                        <v-card>
                          <v-form v-model="isFormValid">
                            <v-card-title>
                              <span class="title"
                                >RD Reference: {{ pvno }}</span
                              >
                            </v-card-title>
                            <v-card-text>
                              <v-container>
                                <v-layout class="text-dialog">
                                  <v-flex>
                                    <span
                                      >Receiver Account Name
                                      <span class="red--text">*</span></span
                                    >
                                    <!-- () =>
                                          /^[a-zA-Z\s]+$/.test(name) ||
                                          'Name must be character' -->
                                    <v-text-field
                                      outline
                                      name="name"
                                      v-model="name"
                                      disabled
                                      :rules="[
                                        () => !!name || 'This field is required'
                                      ]"
                                    ></v-text-field>
                                  </v-flex>
                                </v-layout>
                                <v-layout class="text-dialog">
                                  <v-flex xs6 style="padding-right: 10px;">
                                    <span
                                      >Receiver Account No
                                      <span class="red--text">*</span></span
                                    >
                                    <v-text-field
                                      outline
                                      name="account"
                                      v-model="account"
                                      disabled
                                      :rules="[
                                        () =>
                                          !!account || 'This field is required'
                                      ]"
                                    >
                                    </v-text-field>
                                  </v-flex>
                                  <v-flex xs6>
                                    <span
                                      >Receiver Bank Code
                                      <span class="red--text">*</span></span
                                    >
                                    <v-text-field
                                      outline
                                      name="bankcode"
                                      v-model="bankcode"
                                      disabled
                                      :rules="[
                                        () =>
                                          !!bankcode || 'This field is required'
                                      ]"
                                    >
                                    </v-text-field>
                                  </v-flex>
                                </v-layout>

                                <v-layout class="text-dialog">
                                  <v-flex xs6 style="padding-right: 10px;">
                                    <span
                                      >Receiver Tax ID
                                      <span class="red--text">*</span></span
                                    >
                                    <v-text-field
                                      outline
                                      name="tax_id"
                                      v-model="tax_id"
                                      :rules="[
                                        () =>
                                          !!tax_id || 'This field is required',
                                        () =>
                                          /^\d+$/.test(tax_id) ||
                                          'Tax ID must be number'
                                      ]"
                                    >
                                    </v-text-field>
                                  </v-flex>
                                  <v-flex xs6>
                                    <span
                                      >Wht Condition
                                      <span class="red--text">*</span></span
                                    >
                                    <v-select
                                      outline
                                      :items="wht_cons"
                                      name="wht_condition"
                                      v-model="wht_condition"
                                      :rules="[
                                        () =>
                                          !!wht_condition ||
                                          'This field is required'
                                      ]"
                                    ></v-select>
                                  </v-flex>
                                </v-layout>

                                <v-layout class="text-dialog">
                                  <v-flex>
                                    <span
                                      >Type of Income
                                      <span class="red--text">*</span></span
                                    >
                                    <v-text-field
                                      outline
                                      name="income_type"
                                      v-model="income_type"
                                      :rules="[
                                        () =>
                                          !!income_type ||
                                          'This field is required'
                                      ]"
                                    >
                                    </v-text-field>
                                  </v-flex>
                                </v-layout>
                              </v-container>
                            </v-card-text>
                            <v-card-actions>
                              <v-spacer></v-spacer>
                              <v-btn
                                outline
                                class="btn-reset"
                                text
                                @click="dialog = false"
                              >
                                Close
                              </v-btn>

                              <v-btn
                                class="btn-save"
                                text
                                @click="onSaveTaxInfo()"
                                :disabled="!isFormValid"
                              >
                                Save
                              </v-btn>
                            </v-card-actions>
                          </v-form>
                        </v-card>
                      </v-dialog>
                    </td>
                    <!-- Resend Role Admin -->
                    <!-- <td class="text-xs-center" v-if="role == 'Admin'">
                      <v-dialog v-model="dialog" persistent max-width="600px">
                        <template v-slot:activator="{ on, attrs }"
                          >\
                          <div
                            v-if="
                              props.item.tranfer === 'Rejected' &&
                                role == 'Admin'
                            "
                          >
                            <v-btn
                              outline
                              class="btn-resend"
                              v-bind="attrs"
                              v-on="on"
                              @click="
                                resendTransfer(rd_data, props.item.rd_reference)
                              "
                            >
                              Resend
                            </v-btn>
                          </div>
                          <div v-else></div>
                        </template>
                        <v-card>
                          <v-form v-model="isFormValid">

                            <v-card-text>
                              <v-container>
                                <v-layout>
                                  <v-flex>
                                    <span
                                      >RD Account Name
                                      <span class="red--text">*</span></span
                                    >
                                    <v-text-field
                                      outline
                                      name="name_rd"
                                      v-model="name_rd"
                                      :rules="[
                                        () =>
                                          !!name_rd || 'This field is required',
                                        () =>
                                          /^[a-zA-Z\s]+$/.test(name_rd) ||
                                          'Name must be character'
                                      ]"
                                    ></v-text-field>
                                  </v-flex>
                                </v-layout>
                                <v-layout>
                                  <v-flex xs6 style="padding-right: 10px;">
                                    <span
                                      >RD Account No
                                      <span class="red--text">*</span></span
                                    >
                                    <v-text-field
                                      outline
                                      name="account_no_rd"
                                      v-model="account_no_rd"
                                      :rules="[
                                        () =>
                                          !!account_no_rd ||
                                          'This field is required'
                                      ]"
                                    >
                                    </v-text-field>
                                  </v-flex>
                                  <v-flex xs6>
                                    <span
                                      >RD Bank Code
                                      <span class="red--text">*</span></span
                                    >
                                    <v-text-field
                                      outline
                                      name="bankcode_rd"
                                      v-model="bankcode_rd"
                                      :rules="[
                                        () =>
                                          !!bankcode_rd ||
                                          'This field is required'
                                      ]"
                                    >
                                    </v-text-field>
                                  </v-flex>
                                </v-layout>
                              </v-container>
                            </v-card-text>
                            <v-card-actions>
                              <v-spacer></v-spacer>
                              <v-btn
                                outline
                                class="btn-reset"
                                text
                                @click="dialog = false"
                              >
                                Close
                              </v-btn>

                              <v-btn
                                class="btn-save"
                                text
                                @click="onSaveTransfer()"
                                :disabled="!isFormValid"
                              >
                                Save
                              </v-btn>
                            </v-card-actions>
                          </v-form>
                        </v-card>
                      </v-dialog>
                    </td> -->
                    <!-- --------------------- End Dialog Resend --------------------- -->

                    <!-- <td class="text-xs-left">
                      {{ props.item.order_id }}
                    </td>
                    <td class="text-xs-left">{{ props.item.payment_date }}</td>
                    <td class="text-xs-left">{{ props.item.payment_time }}</td>
                    <td
                      class="text-xs-left"
                      style="min-width:200px;max-width: 200px;"
                    >
                      {{ props.item.detail }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.name }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.receiver_tax_id }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.receiver_account_no }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.receiver_bank_code }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.receiver_email }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.income_type }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.amount_exc_vat }}
                    </td>
                    <td class="text-xs-left">{{ props.item.vat_amount }}</td>
                    <td class="text-xs-left">{{ props.item.grand_total }}</td>
                    <td class="text-xs-left">{{ props.item.wht_rate }} %</td>
                    <td class="text-xs-left">{{ props.item.payer_tax_id }}</td> -->
                  </tr>
                </template>
              </v-data-table>
              <!-- end table mobile -->
            </v-flex>
          </div>

          <!-- ---------------- Table for Admin ------------------- -->
          <div v-if="role == 'Admin'">
            <v-flex md12 pa-1>
              <!-- table desktop -->
              <v-data-table
                v-model="selected"
                :rows-per-page-items="rowperpage"
                :pagination.sync="pagination"
                class="elevation-0 custom-table-cell table-style"
                :headers="headersadmin"
                :items="taxview"
                :search="alltaxsearch"
                item-key="order_id"
                v-if="!mobileView"
                disable-initial-sort
              >
                <template
                  v-slot:items="props"
                  v-bind:class="{ 'active-class-name': isActive(sidemenu) }"
                >
                  <tr style="cursor: pointer;">
                    <td class="text-xs-left">
                      {{ props.item.rd_reference }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.order_id }}
                    </td>
                    <td class="text-xs-left">{{ props.item.payment_date }}</td>
                    <td class="text-xs-left">{{ props.item.payment_time }}</td>
                    <td
                      class="text-xs-left"
                      style="min-width:200px;max-width: 200px;"
                    >
                      {{ props.item.detail }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.name }}
                    </td>
                    <td class="text-xs-center">
                      <v-chip
                        label
                        disabled
                        :color="setStatusColor(props.item.tax_information)"
                        :text-color="setTextColor(props.item.tax_information)"
                        text-font="center"
                        style="width:90px; justify-content: center;font-weight:bold"
                        >{{ props.item.tax_information }}
                      </v-chip>
                    </td>
                    <td class="text-xs-left">
                      <v-chip
                        label
                        disabled
                        :color="setStatusColor(props.item.tranfer)"
                        :text-color="setTextColor(props.item.tranfer)"
                        text-font="center"
                        style="width:90px; justify-content: center;font-weight:bold"
                        >{{ props.item.tranfer }}
                      </v-chip>
                    </td>
                    <td class="text-xs-left">
                      <v-chip
                        label
                        disabled
                        :color="setStatusColor(props.item.reconcile)"
                        :text-color="setTextColor(props.item.reconcile)"
                        text-font="center"
                        style="width:90px; justify-content: center;font-weight:bold"
                        >{{ props.item.reconcile }}
                      </v-chip>
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.receiver_tax_id }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.receiver_account_no }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.receiver_bank_code }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.receiver_email }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.income_type }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.amount_exc_vat }}
                    </td>
                    <td class="text-xs-left">{{ props.item.vat_amount }}</td>
                    <td class="text-xs-left">{{ props.item.grand_total }}</td>
                    <td class="text-xs-left">{{ props.item.wht_rate }} %</td>
                    <td class="text-xs-left">{{ props.item.wht_amount }}</td>
                    <td class="text-xs-left">{{ props.item.payer_tax_id }}</td>
                  </tr>
                </template>
              </v-data-table>
              <!-- end table desktop -->

              <!-- table mobile -->
              <v-data-table
                v-model="selected"
                :rows-per-page-items="rowperpage"
                :pagination.sync="pagination"
                class="elevation-0 custom-table-cell"
                :headers="headersadmin"
                :items="taxview"
                :search="alltaxsearch"
                item-key="order_id"
                v-if="mobileView"
                disable-initial-sort
              >
                <template
                  v-slot:items="props"
                  v-bind:class="{ 'active-class-name': isActive(sidemenu) }"
                >
                  <tr style="cursor: pointer;">
                    <td class="text-xs-left">
                      {{ props.item.rd_reference }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.order_id }}
                    </td>
                    <td class="text-xs-left">{{ props.item.payment_date }}</td>
                    <td class="text-xs-left">{{ props.item.payment_time }}</td>
                    <td
                      class="text-xs-left"
                      style="min-width:200px;max-width: 200px;"
                    >
                      {{ props.item.detail }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.name }}
                    </td>
                    <td class="text-xs-center">
                      <v-chip
                        label
                        disabled
                        :color="setStatusColor(props.item.tax_information)"
                        :text-color="setTextColor(props.item.tax_information)"
                        text-font="center"
                        style="width:90px; justify-content: center;font-weight:bold"
                        >{{ props.item.tax_information }}
                      </v-chip>
                    </td>
                    <td class="text-xs-left">
                      <v-chip
                        label
                        disabled
                        :color="setStatusColor(props.item.tranfer)"
                        :text-color="setTextColor(props.item.tranfer)"
                        text-font="center"
                        style="width:90px; justify-content: center;font-weight:bold"
                        >{{ props.item.tranfer }}
                      </v-chip>
                    </td>
                    <td class="text-xs-left">
                      <v-chip
                        label
                        disabled
                        :color="setStatusColor(props.item.reconcile)"
                        :text-color="setTextColor(props.item.reconcile)"
                        text-font="center"
                        style="width:90px; justify-content: center;font-weight:bold"
                        >{{ props.item.reconcile }}
                      </v-chip>
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.receiver_tax_id }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.receiver_account_no }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.receiver_bank_code }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.receiver_email }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.income_type }}
                    </td>
                    <td class="text-xs-left">
                      {{ props.item.amount_exc_vat }}
                    </td>
                    <td class="text-xs-left">{{ props.item.vat_amount }}</td>
                    <td class="text-xs-left">{{ props.item.grand_total }}</td>
                    <td class="text-xs-left">{{ props.item.wht_rate }} %</td>
                    <td class="text-xs-left">{{ props.item.wht_amount }}</td>
                    <td class="text-xs-left">{{ props.item.payer_tax_id }}</td>
                  </tr>
                </template>
              </v-data-table>
              <!-- end table mobile -->
            </v-flex>
          </div>
          <br />

          <div v-if="role == 'Admin' && btn_resend == true">
            <template>
              <div>
                <v-layout align-end justify-end min-width="auto">
                  <v-dialog v-model="dialogrd" width="500">
                    <template v-slot:activator="{ on, attrs }">
                      <div v-if="role == 'Admin'">
                        <v-btn
                          outline
                          class="btn-resend"
                          v-bind="attrs"
                          v-on="on"
                          @click="resendTransfer(rd_data)"
                        >
                          Resend Tranfer to RD
                        </v-btn>
                      </div>
                      <div v-else></div>
                    </template>
                    <v-card>
                      <v-form v-model="isFormValid">
                        <v-card-text>
                          <v-container>
                            <v-layout class="text-dialog">
                              <v-flex>
                                <span
                                  >RD Account Name
                                  <span class="red--text">*</span></span
                                >
                                <v-text-field
                                  outline
                                  name="name_rd"
                                  v-model="name_rd"
                                  :rules="[
                                    () => !!name_rd || 'This field is required',
                                    () =>
                                      /^[a-zA-Z\s]+$/.test(name_rd) ||
                                      'Name must be character'
                                  ]"
                                ></v-text-field>
                              </v-flex>
                            </v-layout>
                            <v-layout class="text-dialog">
                              <v-flex xs6 style="padding-right: 10px;">
                                <span
                                  >RD Account No
                                  <span class="red--text">*</span></span
                                >
                                <v-text-field
                                  outline
                                  name="account_no_rd"
                                  v-model="account_no_rd"
                                  :rules="[
                                    () =>
                                      !!account_no_rd ||
                                      'This field is required'
                                  ]"
                                >
                                </v-text-field>
                              </v-flex>
                              <v-flex xs6>
                                <span
                                  >RD Bank Code
                                  <span class="red--text">*</span></span
                                >
                                <v-text-field
                                  outline
                                  name="bankcode_rd"
                                  v-model="bankcode_rd"
                                  :rules="[
                                    () =>
                                      !!bankcode_rd || 'This field is required'
                                  ]"
                                >
                                </v-text-field>
                              </v-flex>
                            </v-layout>
                          </v-container>
                        </v-card-text>
                        <v-card-actions>
                          <v-spacer></v-spacer>
                          <v-btn
                            outline
                            class="btn-reset"
                            text
                            @click="dialogrd = false"
                          >
                            Close
                          </v-btn>

                          <v-btn
                            class="btn-save"
                            text
                            @click="onSaveTransfer()"
                            :disabled="!isFormValid"
                          >
                            Save
                          </v-btn>
                        </v-card-actions>
                      </v-form>
                    </v-card>
                  </v-dialog>
                </v-layout>
              </div>
            </template>
          </div>
        </v-card>
      </v-layout>
    </v-flex>

    <!-- --------------------- Detail Dialog -------------------------- -->
    <v-dialog v-model="detail_dialog" fullscreen hide-overlay>
      <v-card>
        <v-card-title>
          <span class="title">RD Reference: {{ d_rd_ref }}</span>
          <v-spacer></v-spacer>
          <v-btn
            class="btn-resend2"
            v-if="d_tax_information == 'Rejected' && role == 'User'"
            @click="openDialogResend()"
            >Resend</v-btn
          >
          <v-btn icon @click="closeDetailDialog()">
            <v-icon>mdi-close</v-icon>
          </v-btn>
        </v-card-title>

        <v-card-text>
          <v-container style="margin-top: -30px">
            <v-layout class="text-dialog">
              <v-flex xs3>
                <span class="text-head">Data Status</span>
              </v-flex>
              <v-flex xs3>
                <span>{{ d_tax_information }}</span>
              </v-flex>
              <v-flex xs3>
                <span class="text-head">Transfer Status</span>
              </v-flex>
              <v-flex xs3>
                <span>{{ d_tranfer }}</span>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" style="margin-top:20px">
              <v-flex xs3>
                <span class="text-head">Reconcile Status</span>
              </v-flex>
              <v-flex xs3>
                <span>{{ d_reconcile }}</span>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" style="margin-top:20px">
              <v-flex xs3>
                <span class="text-head">Receiver Company</span>
              </v-flex>
              <v-flex xs3>
                <span>{{ d_receiver_company }}</span>
              </v-flex>
              <v-flex xs3>
                <span class="text-head">Receiver Tax ID</span>
              </v-flex>
              <v-flex xs3>
                <span>{{ d_receiver_tax_id }}</span>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" style="margin-top:20px">
              <v-flex xs3>
                <span class="text-head">WHT</span>
              </v-flex>
              <v-flex xs3>
                <span>{{ d_wht_amount }}</span>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" style="margin-top:20px">
              <v-flex xs3>
                <span class="text-head">Type of Income</span>
              </v-flex>
              <v-flex>
                <span>{{ d_income_type }}</span>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" style="margin-top:20px">
              <v-flex xs3>
                <span class="text-head">Data Transfer Date</span>
              </v-flex>
              <v-flex>
                <span>{{ d_data_transfer_date }}</span>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" style="margin-top:20px">
              <v-flex xs3>
                <span class="text-head">Transfer Date</span>
              </v-flex>
              <v-flex>
                <span>{{ d_transfer_date }}</span>
              </v-flex>
            </v-layout>

            <v-layout class="text-dialog" style="margin-top:20px">
              <v-flex xs3>
                <span class="text-head">Reconcile Date</span>
              </v-flex>
              <v-flex>
                <span>{{ d_reconcile_date }}</span>
              </v-flex>
            </v-layout>
          </v-container>
        </v-card-text>
      </v-card>
    </v-dialog>
    <!-- --------------------- End Detail Dialog -------------------------- -->

    <!-- --------------------- Resend from Detail Dialog --------------------- -->
    <v-dialog v-model="resend_dialog" persistent max-width="600px">
      <v-card>
        <v-form v-model="isFormValid">
          <v-card-title>
            <span class="title">RD Reference: {{ d_rd_ref }}</span>
          </v-card-title>
          <v-card-text>
            <v-container>
              <v-layout class="text-dialog">
                <v-flex>
                  <span
                    >Receiver Account Name
                    <span class="red--text">*</span></span
                  >
                  <!-- () =>
                        /^[a-zA-Z\s]+$/.test(name) || 'Name must be character' -->
                  <v-text-field
                    outline
                    name="name"
                    v-model="name"
                    disabled
                    :rules="[() => !!name || 'This field is required']"
                  ></v-text-field>
                </v-flex>
              </v-layout>
              <v-layout class="text-dialog">
                <v-flex xs6 style="padding-right: 10px;">
                  <span
                    >Receiver Account No <span class="red--text">*</span></span
                  >
                  <v-text-field
                    outline
                    name="account"
                    v-model="account"
                    disabled
                    :rules="[() => !!account || 'This field is required']"
                  >
                  </v-text-field>
                </v-flex>
                <v-flex xs6>
                  <span
                    >Receiver Bank Code <span class="red--text">*</span></span
                  >
                  <v-text-field
                    outline
                    name="bankcode"
                    v-model="bankcode"
                    disabled
                    :rules="[() => !!bankcode || 'This field is required']"
                  >
                  </v-text-field>
                </v-flex>
              </v-layout>

              <v-layout class="text-dialog">
                <v-flex xs6 style="padding-right: 10px;">
                  <span>Receiver Tax ID <span class="red--text">*</span></span>
                  <v-text-field
                    outline
                    name="tax_id"
                    v-model="tax_id"
                    :rules="[
                      () => !!tax_id || 'This field is required',
                      () => /^\d+$/.test(tax_id) || 'Tax ID must be number'
                    ]"
                  >
                  </v-text-field>
                </v-flex>
                <v-flex xs6>
                  <span>Wht Condition <span class="red--text">*</span></span>
                  <v-select
                    outline
                    :items="wht_cons"
                    name="wht_condition"
                    v-model="wht_condition"
                    :rules="[() => !!wht_condition || 'This field is required']"
                  ></v-select>
                </v-flex>
              </v-layout>

              <v-layout class="text-dialog">
                <v-flex>
                  <span>Type of Income <span class="red--text">*</span></span>
                  <v-select
                    outline
                    :items="income_types"
                    name="income_type"
                    v-model="income_type"
                    :rules="[() => !!income_type || 'This field is required']"
                  ></v-select>
                </v-flex>
              </v-layout>
            </v-container>
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn
              outline
              class="btn-reset"
              text
              @click="resend_dialog = false"
            >
              Close
            </v-btn>

            <v-btn
              class="btn-save"
              text
              @click="onSaveTaxInfo()"
              :disabled="!isFormValid"
            >
              Save
            </v-btn>
          </v-card-actions>
        </v-form>
      </v-card>
    </v-dialog>

    <!-- --------------------- End Resend from Detail Dialog --------------------- -->
  </v-layout>
</template>

<script>
import { sync } from "vuex-pathify";
import moment from "moment";
import XLSX from "xlsx";
import Swal from "sweetalert2";

export default {
  data() {
    return {
      mobileView: "",
      alltaxsearch: "",
      alltax: [],
      custName: this.$cookies.get("custName"),
      role: this.$cookies.get("role"),
      advancedstatus: false,
      headers: [
        { text: "RD Reference", value: "rd_reference", align: "left" },
        {
          text: "Receiver Company",
          value: "receiver_company",
          align: "left"
        },
        { text: "WHT", value: "wht_amount", align: "left" },
        { text: "Data Status", value: "tax_information", align: "left" },
        { text: "Transfer Status", value: "tranfer", align: "left" },
        { text: "Reconcile Status", value: "reconcile", align: "left" },
        {
          text: "Action",
          value: "action",
          align: "center"
        }
        // { text: "Doc No.", value: "order_id", align: "left" },
        // { text: "Payment Date", value: "payment_date", align: "left" },
        // { text: "Payment Time", value: "payment_time", align: "left" },
        // { text: "Detail", value: "detail", align: "left" },
        // {
        //   text: "Receiver Account Name",
        //   value: "name",
        //   align: "left"
        // },
        // {
        //   text: "Receiver Tax ID",
        //   value: "receiver_tax_id",
        //   align: "left"
        // },
        // {
        //   text: "Receiver Account No",
        //   value: "receiver_account_no",
        //   align: "left"
        // },
        // {
        //   text: "Receiver Bank Code",
        //   value: "receiver_bank_code",
        //   align: "left"
        // },
        // { text: "Receiver Email", value: "receiver_email", align: "left" },
        // { text: "Income Type", value: "income_type", align: "left" },
        // { text: "Amount", value: "amount_exc_vat", align: "left" },
        // { text: "VAT", value: "vat_amount", align: "left" },
        // { text: "Grand Total", value: "grand_total", align: "left" },
        // { text: "WHT Rate (%)", value: "wht_rate", align: "left" },
        // { text: "Sender TAX ID", value: "payer_tax_id", align: "left" }
      ],
      headersadmin: [
        { text: "RD Reference", value: "rd_reference", align: "left" },
        { text: "Doc No.", value: "order_id", align: "left" },
        { text: "Payment Date", value: "payment_date", align: "left" },
        { text: "Payment Time", value: "payment_time", align: "left" },
        { text: "Detail", value: "detail", align: "left" },
        {
          text: "Receiver Account Name",
          value: "name",
          align: "left"
        },
        { text: "Tax Information", value: "tax_information", align: "left" },
        { text: "Tranfer to RD", value: "tranfer", align: "left" },
        { text: "Reconcile", value: "reconcile", align: "left" },
        {
          text: "Receiver Tax ID",
          value: "receiver_tax_id",
          align: "left"
        },
        {
          text: "Receiver Account No",
          value: "receiver_account_no",
          align: "left"
        },
        {
          text: "Receiver Bank Code",
          value: "receiver_bank_code",
          align: "left"
        },
        { text: "Receiver Email", value: "receiver_email", align: "left" },
        { text: "Income Type", value: "income_type", align: "left" },
        { text: "Amount", value: "amount_exc_vat", align: "left" },
        { text: "VAT", value: "vat_amount", align: "left" },
        { text: "Grand Total", value: "grand_total", align: "left" },
        { text: "WHT Rate (%)", value: "wht_rate", align: "left" },
        { text: "WHT", value: "wht_amount", align: "left" },
        { text: "Sender TAX ID", value: "payer_tax_id", align: "left" }
      ],
      bills: [],
      selected: [],
      rowperpage: [
        5,
        10,
        25,
        { text: "$vuetify.dataIterator.rowsPerPageAll", value: -1 }
      ],
      pagination: {
        rowsPerPage: 10
      },
      images: {
        arrow: require("../assets/icon/arrow.png"),
        down: require("../assets/icon/down.png"),
        efiling: require("../assets/efiling.png")
      },
      items: ["", "Completed", "In progress", "Rejected"],
      wht_cons: ["A", "O", "R"],
      income_types: [],
      // date: new Date().toISOString().substr(0, 10),
      date: "",
      menu: false,
      rd_ref: "",
      grandtotal: "",
      receiver_bankcode: "",
      receiver_tax_id: "",
      detail: "",
      dialog: false,
      dialogrd: false,
      isFormValid: false,
      pvno: "",
      name: "",
      tax_id: "",
      account: "",
      bankcode: "",
      wht_condition: "",
      income_type: "",
      paymentdate: "",
      searchdate: "",
      name_rd: "",
      account_no_rd: "",
      bankcode_rd: "",
      payment_no: "",
      rd_reference: "",
      rd_data: "",
      reference_rd: "",
      rd_arr: [],
      btn_resend: false,
      detail_dialog: false,
      resend_dialog: false,

      // detail dialog
      d_rd_ref: "",
      d_tax_information: "",
      d_tranfer: "",
      d_reconcile: "",
      d_receiver_company: "",
      d_receiver_tax_id: "",
      d_wht_amount: "",
      d_income_type: "",
      d_transfer_date: "",
      d_data_transfer_date: "",
      d_reconcile_date: "",
      d_receiver_account_no: "",
      d_receiver_bank_code: "",
      d_wht_condition: "",
      d_payment_no: ""
    };
  },
  methods: {
    async getTaxInfo() {
      this.istableloading = true;
      try {
        this.istableloading = true;
        let { data } = await this.axios.get(
          `${process.env.VUE_APP_APIHOST}/tax_info`,
          {
            headers: {
              Authorization: this.$cookies.get("token")
            }
          }
        );
        this.alltax = data.receiver;
        this.rd_data = data.rd;
        // console.log('tax_info: ', data)
        for (let it of data.income_type) {
          this.income_types.push(it.income_type);
        }
        // console.log('income_types: ', this.income_types)
        let _arr = [];
        for (let index = 0; index < this.alltax.length; index++) {
          const element = this.alltax[index];

          if (element && element.tranfer == "Rejected") {
            _arr.push(element.rd_reference);
            this.btn_resend = true;
          }
        }

        this.rd_arr.push(Array.from(new Set(_arr)));
        this.istableloading = false;
      } catch (error) {
        console.log(error.message);
        this.istableloading = false;
      }
    },
    onExport() {
      const dataWS = XLSX.utils.json_to_sheet(this.alltax);
      const wb = XLSX.utils.book_new();
      XLSX.utils.book_append_sheet(wb, dataWS);
      XLSX.writeFile(wb, "Report.xlsx");
    },
    btnAdvancedSearch() {
      if (this.advancedstatus === false) {
        this.advancedstatus = true;
      } else {
        this.advancedstatus = false;
        this.reset();
      }
    },
    reset() {
      this.rd_ref = "";
      this.grandtotal = "";
      this.receiver_bankcode = "";
      this.receiver_tax_id = "";
      this.detail = "";
      this.date = "";
      // this.date = new Date().toISOString().substr(0, 10);
    },
    setStatusColor(status) {
      if (status === "Completed") {
        return "#ECF8EA";
      } else if (status === "In process") {
        return "#FFF7D2";
      } else if (status === "Rejected") {
        return "#FBE5E4";
      } else {
        return "#EEEEEE";
      }
    },
    setTextColor(status) {
      if (status === "Completed") {
        return "#58A144";
      } else if (status === "In process") {
        return "#E9A016";
      } else if (status === "Rejected") {
        return "#D1392B";
      } else {
        return "#757575";
      }
    },
    resendTaxInfo(_item) {
      // console.log("resendTaxInfo: ", _item);
      this.pvno = _item.rd_reference;
      this.name = _item.name;
      this.tax_id = _item.receiver_tax_id;
      this.account = _item.receiver_account_no;
      this.bankcode = _item.receiver_bank_code;
      this.wht_condition = _item.wht_condition;
      this.income_type = _item.income_type;
      this.payment_no = _item.payment_no;
      this.rd_reference = _item.rd_reference;
    },
    resendTransfer(_item) {
      this.name_rd = _item.account_name;
      this.account_no_rd = _item.account_no;
      this.bankcode_rd = _item.bank_code;
    },
    async onSaveTaxInfo() {
      // console.log('onSaveTaxInfo')
      this.istableloading = true;
      try {
        this.istableloading = true;
        let income_type = this.income_type.substring(0, 3);
        var { data } = await this.axios.post(
          `${process.env.VUE_APP_APIHOST}/resend_tax_info`,
          {
            payment_no: this.payment_no,
            receiver_account_name: this.name,
            receiver_tax_id: this.tax_id,
            receiver_account_no: this.account,
            receiver_bank_code: this.bankcode,
            wht_condition: this.wht_condition,
            income_type: income_type,
            createdBy: this.$cookies.get("createdBy"),
            rd_reference: this.rd_reference
          },
          {
            headers: {
              Authorization: this.$cookies.get("token")
            }
          }
        );
        if (data === "Success") {
          Swal.fire({
            title: "Completed",
            text: "",
            icon: "success",
            showConfirmButton: false,
            timer: 1500
          });
          setTimeout(() => {
            this.istableloading = false;
            this.dialog = false;
            this.resend_dialog = false;
            this.d_tax_information = "In process";
            this.d_receiver_tax_id = this.tax_id;
            this.d_wht_condition = this.wht_condition;
            this.d_income_type = this.income_type;
            this.getTaxInfo();
          }, 1800);
        } else {
          Swal.fire({
            title: data,
            text: "",
            icon: "error"
          });
          this.istableloading = false;
        }
      } catch (error) {
        console.log(error.message);
        this.istableloading = false;
        this.dialog = false;
        this.resend_dialog = false;
      }
    },

    async onSaveTransfer() {
      this.istableloading = true;
      try {
        this.istableloading = true;

        var { data } = await this.axios.post(
          `${process.env.VUE_APP_APIHOST}/resend_tranfer_rd`,
          {
            rd_ref: this.rd_arr,
            account_name: this.name_rd,
            account_no: this.account_no_rd,
            bank_code: this.bankcode_rd,
            createdBy: this.$cookies.get("createdBy")
          },
          {
            headers: {
              Authorization: this.$cookies.get("token")
            }
          }
        );
        console.log("resend_tranfer_rd: ", data);
        if (data === "Success") {
          Swal.fire({
            title: "Completed",
            text: "",
            icon: "success",
            showConfirmButton: false,
            timer: 1500
          });
          setTimeout(() => {
            this.istableloading = false;
            this.dialogrd = false;
            this.btn_resend = false;
            this.getTaxInfo();
          }, 1800);
        } else {
          Swal.fire({
            title: data,
            text: "",
            icon: "error"
          });
          this.istableloading = false;
        }
      } catch (error) {
        console.log(error.message);
        this.istableloading = false;
        this.dialog = false;
      }
    },

    addCommas(nStr) {
      nStr += "";
      var x = nStr.split(".");
      var x1 = x[0];
      var x2 = x.length > 1 ? "." + x[1] : "";
      var rgx = /(\d+)(\d{3})/;
      while (rgx.test(x1)) {
        x1 = x1.replace(rgx, "$1" + "," + "$2");
      }
      return x1 + x2;
    },
    handleView() {
      this.mobileView = window.innerWidth <= 990;
    },
    openDialogDetail(props) {
      console.log(props);
      this.detail_dialog = true;
      this.d_rd_ref = props.item.rd_reference;
      this.d_tax_information = props.item.tax_information;
      this.d_tranfer = props.item.tranfer;
      this.d_reconcile = props.item.reconcile;
      this.d_receiver_company = props.item.receiver_company;
      this.d_receiver_tax_id = props.item.receiver_tax_id;
      this.d_wht_amount = props.item.wht_amount;
      this.d_income_type = props.item.income_type;
      if (props.item.validate_date !== "") {
        this.d_data_transfer_date = moment(props.item.validate_date).format(
          "DD/MM/YYYY"
        );
      }
      if (props.item.transfer_date !== "") {
        this.d_transfer_date = moment(props.item.transfer_date).format(
          "DD/MM/YYYY"
        );
      }
      if (props.item.reconclie_date !== "") {
        this.d_reconcile_date = moment(props.item.reconclie_date).format(
          "DD/MM/YYYY"
        );
      }

      this.d_receiver_account_no = props.item.receiver_account_no;
      this.d_receiver_bank_code = props.item.receiver_bank_code;
      this.d_wht_condition = props.item.wht_condition;
      this.d_payment_no = props.item.payment_no;
    },
    openDialogResend() {
      this.resend_dialog = true;
      this.resendTaxInfoFromDetailDialog(
        this.d_rd_ref,
        this.d_receiver_company,
        this.d_receiver_tax_id,
        this.d_receiver_account_no,
        this.d_receiver_bank_code,
        this.d_wht_condition,
        this.d_income_type,
        this.d_payment_no
      );
    },
    resendTaxInfoFromDetailDialog(
      _rdref,
      _receivercompany,
      _receivertaxid,
      _receiveraccountno,
      _receiverbankcode,
      _whtcondition,
      _incometype,
      _paymentno
    ) {
      this.pvno = _rdref;
      this.name = _receivercompany;
      this.tax_id = _receivertaxid;
      this.account = _receiveraccountno;
      this.bankcode = _receiverbankcode;
      this.wht_condition = _whtcondition;
      this.income_type = _incometype;
      this.payment_no = _paymentno;
      this.rd_reference = _rdref;
    },
    closeDetailDialog() {
      this.detail_dialog = false;
      this.d_rd_ref = "";
      this.d_tax_information = "";
      this.d_tranfer = "";
      this.d_reconcile = "";
      this.d_receiver_company = "";
      this.d_receiver_tax_id = "";
      this.d_wht_amount = "";
      this.d_income_type = "";
      this.d_data_transfer_date = "";
      this.d_transfer_date = "";
      this.d_reconcile_date = "";
      this.d_receiver_account_no = "";
      this.d_receiver_bank_code = "";
      this.d_wht_condition = "";
      this.d_payment_no = "";
    }
  },
  computed: {
    taxview() {
      return this.alltax
        .filter(bill => {
          let gtotal = bill.grand_total.toString();
          let _date = moment(bill.payment_date).format("YYYY-MM-DD");
          this.paymentdate = _date.toString();

          let conditions = [
            bill.rd_reference.includes(this.rd_ref),
            gtotal.includes(this.grandtotal),
            bill.receiver_bank_code.includes(
              this.receiver_bankcode.toUpperCase()
            ),
            bill.receiver_tax_id.includes(this.receiver_tax_id),
            bill.detail.includes(this.detail),
            this.paymentdate.includes(this.date)
          ];
          return conditions.every(c => c);
        })
        .map(trans => {
          return {
            ...trans,
            amount_exc_vat: this.addCommas(trans.amount_exc_vat.toFixed(2)),
            vat_amount: this.addCommas(trans.vat_amount.toFixed(2)),
            grand_total: this.addCommas(trans.grand_total.toFixed(2)),
            wht_amount: this.addCommas(trans.wht_amount.toFixed(2)),
            payment_date: moment(trans.payment_date).format("YYYY-MM-DD"),
            payment_time:
              trans.payment_time.substr(0, 2) +
              ":" +
              trans.payment_time.substr(2, 2) +
              ":" +
              trans.payment_time.substr(4, 6)
          };
        });
    },
    invoicemodal: sync("invoicemodal"),
    currentinvoiceno: sync("currentinvoiceno"),
    tokenHashTaxid: sync("tokenHashTaxid"),
    computedDateFormattedMomentjs() {
      return this.date ? moment(this.date).format("YYYY-MM-DD") : "";
    }
  },
  created() {
    this.role = this.$cookies.get("role");
    if (
      (this.role === "User" && this.$cookies.get("token")) ||
      (this.role === "Admin" && this.$cookies.get("token"))
    ) {
      this.getTaxInfo();
    }

    this.handleView();
    window.addEventListener("resize", this.handleView);
  },
  watch: {
    tokenHashTaxid(data) {
      // console.log('paytax tokenHashTaxid: ', data)
      this.getTaxInfo();
    }
  }
};
</script>

<style scoped>
.btn-advanced-search {
  font-style: normal;
  font-weight: bold;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
  color: #3a8300 !important;
  border-radius: 4px;
  margin: 16px 0px 16px 0px;
  text-transform: none;
  font-family: "Sarabun", sans-serif;
}

.btn-export {
  background: #3a8300 !important;
  border-radius: 4px;
  color: white;
  font-weight: bold;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
  text-transform: none;
  margin: 16px 0px 16px 0px;
  font-family: "Sarabun", sans-serif;
}

.text {
  font-size: 14px;
  line-height: 22px;
  color: #212121;
  font-family: "Sarabun", sans-serif;
}

::v-deep
  .v-select.v-text-field--enclosed:not(.v-text-field--single-line)
  .v-select__selections {
  padding-top: 0px;
}

/* ::v-deep
  .theme--light.v-text-field--outline
  > .v-input__control
  > .v-input__slot {
  border: 2px solid #e0e0e0;
} */

.box-advanced {
  border: 1px solid #d2e7c2;
  box-sizing: border-box;
  box-shadow: 0px 4px 6px rgba(233, 251, 219, 0.15);
  border-radius: 4px !important;
  margin: 0px 34px 16px 34px;
}

.btn-reset {
  font-weight: bold;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
  color: #d1392b;
  border-radius: 4px;
  text-transform: none;
  font-family: "Sarabun", sans-serif;
}

::v-deep .v-list__tile__title {
  color: black;
}

.btn-resend {
  font-weight: bold;
  line-height: 24px;
  text-align: center;
  color: #d1392b;
  border-radius: 4px;
  text-transform: none;
  font-size: 16px;
  font-family: "Sarabun", sans-serif;
}

.btn-save {
  background-color: #58a144 !important;
  color: white;
  font-weight: bold;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
  border-radius: 4px;
  text-transform: none;
  font-family: "Sarabun", sans-serif;
}

.title {
  font-weight: bold;
  font-size: 26px !important;
  font-family: "Sarabun", sans-serif !important;
}

/* .v-card__text {
  padding: 0px !important;
} */

.text-dialog {
  font-size: 18px;
  font-family: "Sarabun", sans-serif !important;
}

.text-head {
  font-weight: bold;
}

.btn-resend2 {
  font-weight: bold;
  font-size: 16px;
  line-height: 24px;
  text-align: center;
  color: #ffffff;
  background-color: #d1392b !important;
  border-radius: 4px;
  text-transform: none;
  font-family: "Sarabun", sans-serif;
}
</style>
